package dev.shadowsoffire.apotheosis.adventure.socket.gem;

import java.util.function.BiFunction;
import com.mojang.datafixers.kinds.Applicative;
import java.util.function.Function;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import java.util.List;
import java.util.Collection;
import com.google.common.collect.ImmutableSet;
import java.util.ArrayList;
import net.minecraft.network.FriendlyByteBuf;
import com.google.common.base.Preconditions;
import com.google.common.base.Strings;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import java.util.Set;

record GemClass(String key, Set<LootCategory> types) {
    public static Codec<GemClass> CODEC;
    
    public GemClass {
        Preconditions.checkArgument(!Strings.isNullOrEmpty(this.key), (Object)"Invalid GemClass with null key");
        Preconditions.checkArgument(this.types != null && !this.types.isEmpty(), (Object)"Invalid GemClass with null or empty types");
    }
    
    public void write(final FriendlyByteBuf buf) {
        buf.m_130070_(this.key);
        buf.writeByte(this.types.size());
        this.types.forEach(c -> buf.m_130070_(c.getName()));
    }
    
    public static GemClass read(final FriendlyByteBuf buf) {
        final String key = buf.m_130277_();
        final int size = buf.readByte();
        final List<LootCategory> list = new ArrayList<LootCategory>(size);
        for (int i = 0; i < size; ++i) {
            list.add(LootCategory.byId(buf.m_130277_()));
        }
        return new GemClass(key, (Set<LootCategory>)ImmutableSet.copyOf((Collection)list));
    }
    
    static {
        GemClass.CODEC = (Codec<GemClass>)RecordCodecBuilder.create(inst -> inst.group((App)Codec.STRING.fieldOf("key").forGetter((Function)GemClass::key), (App)LootCategory.SET_CODEC.fieldOf("types").forGetter((Function)GemClass::types)).apply((Applicative)inst, (BiFunction)GemClass::new));
    }
}
